package org.apache.commons.lang3.function;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.util.Objects;

@FunctionalInterface
public interface FailableDoublePredicate<E extends Throwable> {
  public static final org.apache.commons.lang3.function.FailableDoublePredicate FALSE = t -> false;
  
  public static final org.apache.commons.lang3.function.FailableDoublePredicate TRUE = t -> true;
  
  static <E extends Throwable> org.apache.commons.lang3.function.FailableDoublePredicate<E> falsePredicate() {
    return FALSE;
  }
  
  static <E extends Throwable> org.apache.commons.lang3.function.FailableDoublePredicate<E> truePredicate() {
    return TRUE;
  }
  
  default org.apache.commons.lang3.function.FailableDoublePredicate<E> and(org.apache.commons.lang3.function.FailableDoublePredicate<E> other) {
    Objects.requireNonNull(other);
    return t -> (test(t) && other.test(t));
  }
  
  default org.apache.commons.lang3.function.FailableDoublePredicate<E> negate() {
    return t -> !test(t);
  }
  
  default org.apache.commons.lang3.function.FailableDoublePredicate<E> or(org.apache.commons.lang3.function.FailableDoublePredicate<E> other) {
    Objects.requireNonNull(other);
    return t -> (test(t) || other.test(t));
  }
  
  boolean test(double paramDouble) throws E;
}
